import React, {Component} from 'react';
import PropTypes from 'prop-types';

class Loading extends Component {
    constructor(props) {
        super(props);
        this.state = {
            styles: {

            },
            text: {
                ellipsis: '...'
            }
        }
    }

    componentDidMount() {
        (!this.props.animateEllipsis || (this.props.animateEllipsis === "false")) ? null : this.animateEllipsis();
    }

    animateEllipsis() {
        window.setInterval(() => {
            let show = this.state.text.ellipsis;
            show = (show === '...') ? ('') : (show += '.');
            this.setState({
                text: {
                    ellipsis: show
                }
            })
        }, 250);
    }

    render() {
        return (
            <div className="loading">
                <h1
                    className="loading-text"
                    style={{
                        color: this.props.textColor
                    }}
                >
                    {this.props.text}{this.state.text.ellipsis}
                </h1>
            </div>
        )
    }
}

Loading.defaultProps = {
    textColor: 'darkgray',
};

Loading.propTypes = {
    textColor: PropTypes.string.isRequired,
    animateEllipsis: PropTypes.bool,
    text: PropTypes.string
}

export default Loading;